#################################################################
# Tri à bulles
#################################################################

#################################################################
# Algorithme non optimisé
#################################################################

def triABulles_v1(tab):
	global cpt
	n=len(tab)
	for j in range(0, n-1):
		for i in range(0, n-1):
			cpt+=1
			if tab[i]>tab[i+1]:
				tmp=tab[i]
				tab[i]=tab[i+1]
				tab[i+1]=tmp

#################################################################
# Algorithme optimisé
#################################################################

def triABulles_v2(tab):
	global cpt;
	n=len(tab)
	for j in range(0, n-1):
		for i in range(0, n-1-j): # -j pour réduire la boucle
			cpt+=1;
			if tab[i]>tab[i+1]:
				tmp=tab[i];
				tab[i]=tab[i+1];
				tab[i+1]=tmp;

#################################################################
# Algorithme super optimisé
#################################################################

def triABulles(tab):
	global cpt;
	for j in range(len(tab)-1):
		trie=True; # pour sortir si c'est trié
		for i in range(len(tab)-1-j):
			cpt+=1;
			if tab[i]>tab[i+1]:
				tmp=tab[i];
				tab[i]=tab[i+1];
				tab[i+1]=tmp;
				trie=False; # une inversion : pas trié
		if trie:return

#################################################################
# Comparaison des 3 algorithmes avec un petit tableau
#################################################################
cpt=0;
tab=[30,2,3,10,1,20,55,70];
triABulles_v1(tab);
tab;
cpt;

cpt=0;
tab=[30,2,3,10,1,20,55,70];
triABulles_v2(tab);
tab;
cpt;

cpt=0;
tab=[30,2,3,10,1, 20,55,70];
triABulles(tab);
tab;
cpt;